<Exam>
  <Titre>Contrôle continu 1 de structure de données Web - XPath/XQuery</Titre>
  <Infos>Durée 1h30. Seuls les documents utilisés en cours, les exercices faits en TD et les sites web http://www.w3.org/TR/xquery/ et http://www.w3.org/TR/xpath-functions sont autorisés. Données les requêtes XPath/XQuery répondant aux questions suivantes sur le document "claree.xml"

  Chaque réponse sera mise entre { } dans l'élément Q correspondant à la question dans ce document 
(ce document est une requête XQuery). A la fin de l'épreuve ce document est à envoyer par email à bruno@univ-tln.fr avec votre adresse de l'upf.
</Infos>
  <Question>
    <I>la séquence des noeuds itinéraires de l’arbre du document claree.xml</I>
    <Q>{
      fn:doc("claree.xml")/guide/vallon/itinéraire
    }</Q>
  </Question>
  <Question>
    <I>Nom des vallons possédant au moins deux itinéraires cotés **** ?</I>
    <Q>{
    fn:doc("claree.xml")//vallon[count(itinéraire[cotation = "****"]) > 1]/nom
    }</Q>
  </Question>
  <Question>
    <I>Nom du 2e itinéraire ** du Vallon des Muandes ?</I>
    <Q>{
    fn:doc("claree.xml")//vallon[nom = "Vallon des Muandes"]/itinéraire[cotation = "**"][2]/nom/text()
    }</Q>
  </Question>
  <Question>
    <I>Les noms des itinéraires du vallon "vallon des Muandes", cotés ** et ne comportant pas de note de prudence.</I>
    <Q>{
    fn:doc("claree.xml")//vallon[nom = "Vallon des Muandes"] /itinéraire[cotation = "**" and not (para/note[@type = "prudence"])]/nom
    }</Q>
  </Question>
  <Question>
    <I>Les noms des itinéraires du vallon des Muandes décrits après celui de la "Pointe de Névache" ?</I>
    <Q>{
    fn:doc("claree.xml")//vallon[nom = "Vallon des Muandes"]/itinéraire[nom = "Pointe de Névache"]/following-sibling::itinéraire
    }</Q>
  </Question>
  <Question>
    <I>Le nom du dernier vallon du guide ?</I>
    <Q>{
    fn:doc("claree.xml")//vallon[last()]/nom
    }</Q>
  </Question>
  <Question>
    <I>Textes de toutes les notes de type « prudence » ?</I>
    <Q>{
    fn:doc("claree.xml")//note[@type = "prudence"]/text()
    }</Q>
  </Question>
  <Question>
    <I>Nom du vallon dans lequel se trouve l’itinéraire I15.1 ?</I>
    <Q>{
    fn:doc("claree.xml")//itinéraire[@id = "I15.1"]/parent::vallon/nom
    }</Q>
    ou bien :
    <Q>{
    fn:doc("claree.xml")//itinéraire[@id = "I15.1"]/../nom
    }</Q>
    ou bien 
    <Q>{
    fn:doc("claree.xml")//vallon[itinéraire[@id = "I15.1"]]/nom
    }</Q>
  </Question>
  <Question>
    <I>séquence des noeuds élément de type vallon ou itinéraire du document claree.xml.</I>
    <Q>{
    fn:doc("claree.xml")/(vallon | itinéraire)
    }</Q>
  </Question>
  <Question>
    <I>Noms et altitude de chaque itinéraire **** ? Le résultat sera une séquence d'élements itinéraire avec deux attributs</I>
    <Q>{
    for $i in fn:doc("claree.xml")//itinéraire
    where $i/cotation = "****"
    return <itinéraire nom="{$i/nom}" alt="{$i/alt}"/>
    }</Q>
  </Question>
  <Question>
    <I>Itinéraires, triés par difficulté décroissante (cotation) puis par ordre alphabétique de nom ?</I>
    <Q>{
    for $i in fn:doc("claree.xml")//itinéraire
    order by $i/cotation descending, $i/nom ascending
    return $i
    }</Q>
  </Question>
  <Question>
    <I>Nom et altitude des itinéraires *** du Vallon dont le nom est "Vallon des Muandes" triés par ordre alphabétique de nom ?</I>
    <Q>{     
      for $v in fn:doc("claree.xml")//vallon,
      $i in $v/itinéraire
      let $n := $i/nom
      where $i/cotation = "***" and $v/nom = "Vallon des Muandes"
      order by $n
      return <iti n="{$n}" a="{$i/alt}"/>
    }</Q>
  </Question>
  <Question>
    <I>Noms des itinéraires cités dans la description de l’itinéraire de la Pointe de Névache ?</I>
    <Q>{
    fn:doc("claree.xml")//itinéraire[@id = fn:doc("claree.xml")//itinéraire[nom = "Pointe de Névache"]//renvoi/@cible]
    }</Q>
  </Question>
  <Question>
    <I>Liste des paires nom de vallon-nom d’itinéraire ?</I>
    <Q>{for $v in fn:doc("claree.xml")//vallon
    for $i in $v/itinéraire
    return <vi vallon="{$v/nom}" itinéraire="{$i/nom}"/>
    }</Q>
  </Question>
  <Question>
    <I>Est-ce que tous les itinéraires ont une altitude supérieure à 2000m ?</I>
    <Q>{
    every $i in fn:doc("claree.xml")//itinéraire satisfies $i/alt > 2000
    }</Q>
  </Question>
  <Question>
    <I>Existe-t-il des itinéraires de même altitude ?</I>
    <Q>{
    let $itis := fn:doc("claree.xml")//itinéraire
    return some $i1 in $itis, $i2 in $itis
    satisfies fn:not($i1 is $i2) and $i1/alt = $i2/alt
    }</Q>
  </Question>
 <Question>
    <I>Liste des id des itinéraires groupés par cotation (les cotations existantes doivent être extraites) ?
       <cotation valeur="*">
            <itinéraire>I1.1</itinéraire>
       </cotation>
       <cotation valeur="***">
            <itinéraire>I1.2</itinéraire>
       ...
       </cotation>
    </I>
    <Q>{
    let $cotations := fn:distinct-values(fn:doc("claree.xml")//cotation)
    return 
	for $c in $cotations return 
		<cotation valeur="{$c}">
		 {for $i in fn:doc("claree.xml")//itinéraire[cotation=$c]
			return <itinéraire>{fn:data($i/@id)}</itinéraire>}
		</cotation>
	 
    }</Q>
  </Question>
</Exam>
